from urllib.parse import quote
import requests
import json

# Request parameters
api_key = "PCW45-12345-12345-1234X"
sort_code = "100000"
account_number = "31510604"

# Prepare request and encode user-entered parameters with %xx encoding
request_url = f"https://ws.postcoder.com/pcw/{api_key}/bank"

request_body = {
    "sortcode": f"{quote(sort_code, safe='')}",
    "accountnumber": f"{quote(account_number, safe='')}",
}

# Send request
response = requests.post(request_url, json=request_body)

# Process response
if response.status_code == 200:
    json = response.json()
    print(json["valid"], json["bankname"], json["branchname"])
else:
    print(f"Request error: {response.content.decode()}")